//---------------------------------------------------------------------------

#include <vcl.h>
#include <vcl\Clipbrd.hpp>
#pragma hdrstop

#include "ClipForm.h"
#include "about.h"
#include "lang.h"
#include "setup.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TClipForm1 *ClipForm1;


//---------------------------------------------------------------------------
// TClipForm1
//---------------------------------------------------------------------------
__fastcall TClipForm1::TClipForm1(TComponent* Owner)
		  : TForm(Owner)
{
 HotKeySet=false;
 Hide();
 if (FileExists("active.ico"))
     ImageActive->Picture->Icon->LoadFromFile("active.ico");
 if (FileExists("inactive.ico"))
     ImageInactive->Picture->Icon->LoadFromFile("inactive.ico");
 TrayIcon_Create ((AnsiString("HovText - ") + LangText(TE_Active)).c_str(),ImageActive->Picture->Icon->Handle);
 if (GetRegInt("StartAs")==2) {
   SetActive(GetRegInt("LastState"));
 } else
 {
   SetActive(GetRegInt("StartAs")==0);
 }
 Active1->Caption=LangText(TE_Active);
 Exit1->Caption=LangText(TE_Exit);
 About1->Caption=LangText(TE_About);
 Options1->Caption=LangText(TE_Options);
 SetHotKey();
}

__fastcall TClipForm1::~TClipForm1()
{
 if (GetRegInt("StartAs")==2) {
   SetRegInt("LastState",Active1->Checked);
 }
 UnsetHotKey();
 TrayIcon_Delete();
}


//---------------------------------------------------------------------------
// Clipboard Functions:
//---------------------------------------------------------------------------

void __fastcall TClipForm1::ConvertClip()
{
	try {
	  static char TextBuf[60000];
	  TClipboard *clip= Clipboard();

	  if (clip->HasFormat(CF_TEXT))
	  {
		  clip->GetTextBuf(TextBuf, sizeof TextBuf);
		  clip->SetTextBuf(TextBuf);
	  }
	} catch (...) {
	}
}


//---------------------------------------------------------------------------
// TrayIcon Functions:
//---------------------------------------------------------------------------

 void TClipForm1::TrayIcon_Create (const char *tipText,HICON hIcon)
  {

	 NOTIFYICONDATA info;
	 memset(&info,0,sizeof(info));
	 info.cbSize          =sizeof(info) ;
	 info.hWnd            =Handle;
	 info.uID             =WM_TRAY_ICON_ID;
	 info.uCallbackMessage=WM_TRAY_ICON_MESSAGE;
	 info.hIcon           =hIcon;
	 strncpy (info.szTip,tipText,sizeof(info.szTip));
	 info.szTip[sizeof(info.szTip)-1]='0';
	 info.uFlags          =NIF_MESSAGE | NIF_ICON | NIF_TIP ;
	 Shell_NotifyIcon(NIM_ADD,&info) ;
  }


//---------------------------------------------------------------------------
void TClipForm1::TrayIcon_ModifyTip(const char *tipText)
{
  NOTIFYICONDATA info;
  memset(&info,0,sizeof(info));
  info.cbSize          =sizeof(info) ;
  info.hWnd            =Handle;
  info.uID             =WM_TRAY_ICON_ID;
  info.uFlags          =NIF_TIP;
  strncpy(info.szTip,tipText,sizeof(info.szTip));
  info.szTip[sizeof(info.szTip)-1]='\0';
  Shell_NotifyIcon(NIM_MODIFY,&info);
}
//---------------------------------------------------------------------------
void TClipForm1::TrayIcon_ModifyIcon(HICON hIcon)
{
  NOTIFYICONDATA info;
  memset(&info,0,sizeof(info));
  info.cbSize          =sizeof(info) ;
  info.hWnd            =Handle;
  info.uID             =WM_TRAY_ICON_ID;
  info.hIcon           =hIcon;
  info.uFlags          =NIF_ICON;
  Shell_NotifyIcon(NIM_MODIFY,&info) ;
}
//---------------------------------------------------------------------------
void TClipForm1::TrayIcon_Delete(void)
{
  NOTIFYICONDATA info;
  memset(&info,0,sizeof(info));
  info.cbSize=sizeof(info);
  info.hWnd  =Handle;
  info.uID   =WM_TRAY_ICON_ID;
  Shell_NotifyIcon(NIM_DELETE,&info);
}
//---------------------------------------------------------------------------
void TClipForm1::TrayIcon_HandleMessage(TMessage &Message)
{
  switch (Message.LParam)
  {
	 case WM_LBUTTONDBLCLK:
		break;
	 case WM_RBUTTONDOWN:
	 {
		POINT point;
		HWND Prev;
		::GetCursorPos(&point);
		SetForegroundWindow(Handle);

		PopupMenu1->Popup(point.x,point.y);
		Prev= GetForegroundWindow();
		SetForegroundWindow(Handle);
		SetForegroundWindow(Prev);
	 }
		break;
	 case WM_RBUTTONDBLCLK:
	 case WM_MOUSEMOVE:
	 case WM_LBUTTONDOWN:
		break;
  }
}
//---------------------------------------------------------------------------
// Menu Functions:
//---------------------------------------------------------------------------

void __fastcall TClipForm1::Exit1Click(TObject *Sender)
{
	Close();
}


//---------------------------------------------------------------------------

void __fastcall TClipForm1::SetActive(bool active)
{
   Active1->Checked=active;
	if (active) {
		TrayIcon_ModifyTip((AnsiString("HovText - ") + LangText(TE_Active)).c_str());
		TrayIcon_ModifyIcon(ImageActive->Picture->Icon->Handle);
	} else {
		TrayIcon_ModifyTip((AnsiString("HovText - ") + LangText(TE_Active)).c_str());
		TrayIcon_ModifyIcon(ImageInactive->Picture->Icon->Handle);
	}
}

void __fastcall TClipForm1::Active1Click(TObject *Sender)
{

   SetActive(!Active1->Checked);
}

//---------------------------------------------------------------------------

void __fastcall TClipForm1::About1Click(TObject *Sender)
{
  AboutBox->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TClipForm1::Options1Click(TObject *Sender)
{
  if (SetupForm->ShowModal()==mrOk)
    SetHotKey();
}
//---------------------------------------------------------------------------


void __fastcall TClipForm1::SetHotKey()
{
  Word TheKey;
  TShiftState TheShiftState;
  UnsetHotKey();
   ShortCutToKey(SetupForm->GetHotKey(), TheKey, TheShiftState);
   if (TheKey!=0)
   {
     unsigned fsMod=0;
     if (TheShiftState.Contains(ssShift)) fsMod |= MOD_SHIFT;
     if (TheShiftState.Contains(ssCtrl)) fsMod |= MOD_CONTROL;
     if (TheShiftState.Contains(ssAlt)) fsMod |= MOD_ALT;
     RegisterHotKey(Handle, 1, fsMod, TheKey);
     HotKeySet=true;
   }
}

void __fastcall TClipForm1::UnsetHotKey()
{
  if (HotKeySet)
     UnregisterHotKey( Handle, 1 );
  HotKeySet=false;
}

void __fastcall TClipForm1::WMHotKey(TMessage &Message)
{
  Active1Click(this);
}


//---------------------------------------------------------------------------
// Timer:
//---------------------------------------------------------------------------
void __fastcall TClipForm1::Timer1Timer(TObject *Sender)
{
	if (Active1->Checked)
		ConvertClip();
}
//---------------------------------------------------------------------------


